#include <stdio.h>
#include <stdlib.h>
#include "ListaEncadeada.h"

void inicializar(Lista *l)
{
  l->inicio = NULL;
  l->fim = NULL;
}

void insInicio(Lista *l, Tipo v)
{
  No *aux = (No *) malloc(sizeof(No));
  aux->valor = v;
  aux->prox = l->inicio;
  l->inicio = aux;
  if (l->fim == NULL)
    l->fim = aux;
}

void insFim(Lista *l, Tipo v)
{
  No *aux = (No *) malloc(sizeof(No));
  aux->valor = v;
  aux->prox = NULL;
  if (l->fim != NULL)
    l->fim->prox = aux;
  else
    l->inicio = aux;
  l->fim = aux;
}

void insOrdenado(Lista *l, Tipo v)
{
  No *aux, *atual, *anterior;
  if (l->inicio == NULL || v < l->inicio->valor)
    insInicio(l, v);
  atual = l->inicio;
  while (atual != NULL && v > atual->valor)
  {
    anterior = atual;
    atual = atual->prox;
  } 
  if (atual != NULL && v == atual->valor)
    return;
  aux = (No *) malloc(sizeof(No));
  aux->valor = v;
  aux->prox = atual;
  anterior->prox = aux;
}

Tipo remInicio(Lista *l)
{
  Tipo resp;
  No *aux;
  if (vazia(l))
  {
    printf("Lista vazia!\n");
    exit(1);
  }
  aux = l->inicio;
  l->inicio = aux->prox;
  resp = aux->valor;
  free(aux);
  if (l->inicio == NULL)
    l->fim = NULL;
  return resp;
}

Tipo remFim(Lista *l)
{
  Tipo resp;
  No *aux;
  if (vazia(l))
  {
    printf("Lista vazia!\n");
    exit(1);
  }
  aux = l->inicio;
  if (l->inicio == l->fim)
  {
    l->inicio = l->fim = NULL;
  }
  else
  {
    while(aux->prox != l->fim)
      aux = aux->prox;
    l->fim = aux;
    aux = aux->prox;
    l->fim->prox = NULL;
  }
  resp = aux->valor;
  free(aux);
  return resp;
}

int remElem(Lista *l, Tipo v)
{
  No *atual = l->inicio, *anterior;
  while (atual != NULL && v != atual->valor)
  {
    anterior = atual;
    atual = atual->prox;
  }
  if (atual == NULL)
    return 0;
  else
  {
    if (atual == l->inicio)
    {
      l->inicio = atual->prox;
      if (l->inicio == NULL)
        l->fim = NULL;
    }
    else if (atual == l->fim)
    {
      l->fim = anterior;
      anterior->prox = NULL;
    }
    else
    {
      anterior->prox = atual->prox;
    }
    free(atual);
    return 1;
  }
}

int vazia(Lista *l)
{
  return l->inicio == NULL;
}

void imprime(Lista *l)
{
  No *aux = l->inicio;
  printf("{");
  while (aux != NULL)
  {
    printf("%i ", aux->valor);
    aux = aux->prox;
  }
  printf("}\n");
}

int consulta(Lista *l, Tipo v)
{
  No *aux = l->inicio;
  while (aux != NULL && aux->valor != v)
    aux = aux->prox;
  return aux != NULL;
}




Tipo remPosicao(Lista *l, int posicao)
{
  Tipo resp;
  No *atual, *anterior;
  int posicaoAtual = 1;
  if (vazia(l))
  {
    printf("Lista vazia!\n");
    exit(1);
  }
  atual = l->inicio;
  if (posicao == 1)
  {
    l->inicio = atual->prox;
    resp = atual->valor;
    free(atual);
    if (l->inicio == NULL)
      l->fim = NULL;
  }
  else
  {
    while (atual != NULL && posicaoAtual < posicao)
    {
      anterior = atual;
      atual = atual->prox;
      ++posicaoAtual;
    }
    if (atual == NULL)
    {
      printf("Posicao inexistente!\n");
      exit(1);
    }
    anterior->prox = atual->prox;
    if (atual == l->fim)
    {
      l->fim = anterior;
    }
    resp = atual->valor;
    free(atual);
  }
  return resp;
}
